'use strict';

const babel = {
  plugins: [
    [
      require.resolve('babel-plugin-root-import'),
      {
        rootPathPrefix: '~',
        rootPathSuffix: 'src',
      },
    ],
    [
      '@babel/plugin-proposal-object-rest-spread',
      { loose: true, useBuiltIns: true },
    ],
    ['@babel/plugin-proposal-private-methods', { loose: true }],
    ['@babel/plugin-proposal-nullish-coalescing-operator', { loose: true }],
    ['@babel/plugin-proposal-class-properties', { loose: true }],
    ['@babel/plugin-transform-runtime'],
  ],
  // Settings for the Old Browsers along with CoreJs polyfills
  presets: [
    [
      '@babel/preset-env',
      { targets: { esmodules: false }, useBuiltIns: 'usage', corejs: '3' },
    ],
    ['@babel/preset-react', { useBuiltIns: true, throwIfNamespace: false }],
    ['@babel/preset-typescript', { isTsx: true }],
  ],
  // Settings for the New Browsers along with CoreJs polyfills
  presetsNew: [
    [
      '@babel/preset-env',
      { targets: { esmodules: true }, useBuiltIns: 'usage', corejs: '3' },
    ],
    ['@babel/preset-react', { useBuiltIns: true, throwIfNamespace: false }],
    ['@babel/preset-typescript', { isTsx: true }],
  ],
  ignore: ['src/helpers/polyfills/*.js'],
};

module.exports = { babel };
